library ieee;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity configcpld is
   port(
      FXCLK     : in std_logic;
      PROG_SD   : in std_logic;
      PROG_GPIF : in std_logic;
      FLAG      : in std_logic;
      SDCLK     : out std_logic;
      CCLK      : out std_logic;
      SDDO      : in std_logic;
      D0        : out std_logic
   );
end configcpld;


architecture RTL of configcpld is

--signal declaration
signal run_sd : std_logic := '0';
signal sdcounter : std_logic_vector(12 downto 0) := (others => '0');
signal sdclk_buf : std_logic := '1';

begin
    CCLK <= ( ( FLAG and (not PROG_GPIF) ) or
                sdcounter(0)
            ) when ((PROG_GPIF = '0') or (run_sd = '1')) else 'Z';

    SDCLK <= sdclk_buf when run_sd = '1' else 'Z';

    D0 <= SDDO when run_sd = '1' else 'Z';

    dpFXCLK: process(FXCLK)
    begin
         if FXCLK' event and FXCLK = '1' then
            if run_sd = '1'
            then
        	if sdcounter(12 downto 1) /= "111111111111" 
        	then
        	    sdclk_buf <= not sdclk_buf;
        	end if;
        	if sdcounter = "1111111111111" 
        	then
        	    run_sd <= '0';
        	else
        	    sdcounter <= sdcounter + 1;
        	end if;
            else
        	if (PROG_GPIF = '1') and (PROG_SD = '0')
        	then
        	    run_sd <= '1';
        	end if;
    	        sdcounter <= (others => '0');
    	        sdclk_buf <= '1';
    	    end if;
    	 end if;
    end process dpFXCLK;

end RTL;
